## jackd2 1.9.7~dfsg

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os
import Utils
import Options
import commands
g_maxlen = 40
import shutil
import Task
import re
import Logs

VERSION='1.9.7'
APPNAME='jack'
JACK_API_VERSION = '0.1.0'

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'

def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print "%s :" % msg.ljust(g_maxlen),
        Utils.pprint(color, status)
    else:
        print "%s" % msg.ljust(g_maxlen)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'GREEN')
    else:
        display_msg(msg, "no", 'YELLOW')

def create_svnversion_task(bld, header='svnversion.h', define=None):
    import Constants, Build

    cmd = '../svnversion_regenerate.sh ${TGT}'
    if define:
        cmd += " " + define

    cls = Task.simple_task_type('svnversion', cmd, color='BLUE', before='cc')
    cls.runnable_status = lambda self: Constants.RUN_ME

    def post_run(self):
        sg = Utils.h_file(self.outputs[0].abspath(self.env))
        #print sg.encode('hex')
        Build.bld.node_sigs[self.env.variant()][self.outputs[0].id] = sg
    cls.post_run = post_run

    tsk = cls(bld.env.copy())
    tsk.inputs = []
    tsk.outputs = [bld.path.find_or_declare(header)]

def set_options(opt):
    # options provided by the modules
    opt.tool_options('compiler_cxx')
    opt.tool_options('compiler_cc')

    opt.add_option('--libdir', type='string', help="Library directory [Default: <prefix>/lib]")
    opt.add_option('--libdir32', type='string', help="32bit Library directory [Default: <prefix>/lib32]")
    opt.add_option('--mandir', type='string', help="Manpage directory [Default: <prefix>/share/man/man1]")
    opt.add_option('--dbus', action='store_true', default=False, help='Enable D-Bus JACK (jackdbus)')
    opt.add_option('--classic', action='store_true', default=False, help='Force enable standard JACK (jackd) even if D-Bus JACK (jackdbus) is enabled too')
    opt.add_option('--doxygen', action='store_true', default=False, help='Enable build of doxygen documentation')
    opt.add_option('--profile', action='store_true', default=False, help='Build with engine profiling')
    opt.add_option('--mixed', action='store_true', default=False, help='Build with 32/64 bits mixed mode')
    opt.add_option('--clients', default=64, type="int", dest="clients", help='Maximum number of JACK clients')
    opt.add_option('--ports-per-application', default=768, type="int", dest="application_ports", help='Maximum number of ports per application')
    opt.add_option('--debug', action='store_true', default=False, dest='debug', help='Build debuggable binaries')
    opt.add_option('--firewire', action='store_true', default=False, help='Enable FireWire driver (FFADO)')
    opt.add_option('--freebob', action='store_true', default=False, help='Enable FreeBob driver')
    opt.add_option('--alsa', action='store_true', default=False, help='Enable ALSA driver')
    opt.sub_options('dbus')

def configure(conf):
    platform = Utils.detect_platform()
    conf.env['IS_MACOSX'] = platform == 'darwin'
    conf.env['IS_LINUX'] = platform == 'linux' or platform == 'posix'
    conf.env['IS_SUN'] = platform == 'sunos'

    if conf.env['IS_LINUX']:
        Utils.pprint('CYAN', "Linux detected")

    if conf.env['IS_MACOSX']:
        Utils.pprint('CYAN', "MacOS X detected")

    if conf.env['IS_SUN']:
        Utils.pprint('CYAN', "SunOS detected")

    if conf.env['IS_LINUX']:
        conf.check_tool('compiler_cxx')
        conf.check_tool('compiler_cc')

    if conf.env['IS_MACOSX']:
        conf.check_tool('compiler_cxx')
        conf.check_tool('compiler_cc')

    # waf 1.5 : check_tool('compiler_cxx') and check_tool('compiler_cc') do not work correctly, so explicit use of gcc and g++
    if conf.env['IS_SUN']:
        conf.check_tool('g++')
        conf.check_tool('gcc')

    #if conf.env['IS_SUN']:
    #   conf.check_tool('compiler_cxx')
    #   conf.check_tool('compiler_cc')
 
    conf.env.append_unique('CXXFLAGS', '-Wall')
    conf.env.append_unique('CCFLAGS', '-Wall')

    conf.sub_config('common')
    if conf.env['IS_LINUX']:
        conf.sub_config('linux')
        if Options.options.alsa and not conf.env['BUILD_DRIVER_ALSA']:
            conf.fatal('ALSA driver was explicitly requested but cannot be built')
        if Options.options.freebob and not conf.env['BUILD_DRIVER_FREEBOB']:
            conf.fatal('FreeBob driver was explicitly requested but cannot be built')
        if Options.options.firewire and not conf.env['BUILD_DRIVER_FFADO']:
            conf.fatal('FFADO driver was explicitly requested but cannot be built')
        conf.env['BUILD_DRIVER_ALSA'] = Options.options.alsa
        conf.env['BUILD_DRIVER_FFADO'] = Options.options.firewire
        conf.env['BUILD_DRIVER_FREEBOB'] = Options.options.freebob
    if Options.options.dbus:
        conf.sub_config('dbus')
        if conf.env['BUILD_JACKDBUS'] != True:
            conf.fatal('jackdbus was explicitly requested but cannot be built')
    conf.sub_config('example-clients')

    if conf.check_cfg(package='celt', atleast_version='0.11.0', args='--cflags --libs'):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 1)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.8.0', args='--cflags --libs'):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 1)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.7.0', args='--cflags --libs'):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 1)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.5.0', args='--cflags --libs', required=True):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 1)
    else:
        conf.define('HAVE_CELT', 0)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)

    conf.env['LIB_PTHREAD'] = ['pthread']
    conf.env['LIB_DL'] = ['dl']
    conf.env['LIB_RT'] = ['rt']
    conf.env['JACK_API_VERSION'] = JACK_API_VERSION
    conf.env['JACK_VERSION'] = VERSION

    conf.env['BUILD_DOXYGEN_DOCS'] = Options.options.doxygen
    conf.env['BUILD_WITH_PROFILE'] = Options.options.profile
    conf.env['BUILD_WITH_32_64'] = Options.options.mixed
    conf.env['BUILD_CLASSIC'] = Options.options.classic
    conf.env['BUILD_DEBUG'] = Options.options.debug

    if conf.env['BUILD_JACKDBUS']:
        conf.env['BUILD_JACKD'] = conf.env['BUILD_CLASSIC']
    else:
        conf.env['BUILD_JACKD'] = True

    if Options.options.libdir:
        conf.env['LIBDIR'] = conf.env['PREFIX'] + Options.options.libdir
    else:
        conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib'

    if Options.options.mandir:
        conf.env['MANDIR'] = conf.env['PREFIX'] + Options.options.mandir
    else:
        conf.env['MANDIR'] = conf.env['PREFIX'] + '/share/man/man1'

    if conf.env['BUILD_DEBUG']:
        conf.env.append_unique('CXXFLAGS', '-g')
        conf.env.append_unique('CCFLAGS', '-g')
        conf.env.append_unique('LINKFLAGS', '-g')

    conf.define('CLIENT_NUM', Options.options.clients)
    conf.define('PORT_NUM_FOR_CLIENT', Options.options.application_ports)

    conf.define('ADDON_DIR', os.path.normpath(os.path.join(conf.env['LIBDIR'], 'jack')))
    conf.define('JACK_LOCATION', os.path.normpath(os.path.join(conf.env['PREFIX'], 'bin')))
    conf.define('USE_POSIX_SHM', 1)
    conf.define('JACKMP', 1)
    if conf.env['BUILD_JACKDBUS'] == True:
        conf.define('JACK_DBUS', 1)
        if conf.env['BUILD_JACKD'] == False:
            conf.define('USE_LIBDBUS_AUTOLAUNCH', 1)
    if conf.env['BUILD_WITH_PROFILE'] == True:
        conf.define('JACK_MONITOR', 1)
    if conf.env['BUILD_WITH_32_64'] == True:
        conf.define('JACK_32_64', 1)
    conf.write_config_header('config.h')

    svnrev = None
    if os.access('svnversion.h', os.R_OK):
        data = file('svnversion.h').read()
        m = re.match(r'^#define SVN_VERSION "([^"]*)"$', data)
        if m != None:
            svnrev = m.group(1)

    conf.env.append_unique('LINKFLAGS', '-lm -lstdc++')

    if Options.options.mixed == True:
        env_variant2 = conf.env.copy()
        conf.set_env_name('lib32', env_variant2)
        env_variant2.set_variant('lib32')
        conf.setenv('lib32')
        conf.env.append_unique('CXXFLAGS', '-m32')
        conf.env.append_unique('CCFLAGS', '-m32')
        conf.env.append_unique('LINKFLAGS', '-m32')
        if Options.options.libdir32:
            conf.env['LIBDIR'] = conf.env['PREFIX'] + Options.options.libdir32
        else:
            conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib32'
        conf.write_config_header('config.h')

    print
    display_msg("==================")
    version_msg = "JACK " + VERSION
    if svnrev:
        version_msg += " exported from r" + svnrev
    else:
        version_msg += " svn revision will checked and eventually updated during build"
    print version_msg

    print "Build with a maximum of %d JACK clients" % conf.env['CLIENT_NUM']
    print "Build with a maximum of %d ports per application" % conf.env['PORT_NUM_FOR_CLIENT']
 
    display_msg("Install prefix", conf.env['PREFIX'], 'CYAN')
    display_msg("Library directory", conf.env['LIBDIR'], 'CYAN')
    display_msg("Drivers directory", conf.env['ADDON_DIR'], 'CYAN')
    display_feature('Build debuggable binaries', conf.env['BUILD_DEBUG'])
    display_msg('C compiler flags', repr(conf.env['CCFLAGS']))
    display_msg('C++ compiler flags', repr(conf.env['CXXFLAGS']))
    display_msg('Linker flags', repr(conf.env['LINKFLAGS']))
    display_feature('Build doxygen documentation', conf.env['BUILD_DOXYGEN_DOCS'])
    display_feature('Build with engine profiling', conf.env['BUILD_WITH_PROFILE'])
    display_feature('Build with 32/64 bits mixed mode', conf.env['BUILD_WITH_32_64'])

    display_feature('Build standard JACK (jackd)', conf.env['BUILD_JACKD'])
    display_feature('Build D-Bus JACK (jackdbus)', conf.env['BUILD_JACKDBUS'])

    if conf.env['BUILD_JACKDBUS'] and conf.env['BUILD_JACKD']:
        print Logs.colors.RED + 'WARNING !! mixing both jackd and jackdbus may cause issues:' + Logs.colors.NORMAL
        print Logs.colors.RED + 'WARNING !! jackdbus does not use .jackdrc nor qjackctl settings' + Logs.colors.NORMAL

    if conf.env['IS_LINUX']:
        display_feature('Build with ALSA support', conf.env['BUILD_DRIVER_ALSA'] == True)
        display_feature('Build with FireWire (FreeBob) support', conf.env['BUILD_DRIVER_FREEBOB'] == True)
        display_feature('Build with FireWire (FFADO) support', conf.env['BUILD_DRIVER_FFADO'] == True)
       
    if conf.env['BUILD_JACKDBUS'] == True:
        display_msg('D-Bus service install directory', conf.env['DBUS_SERVICES_DIR'], 'CYAN')
        #display_msg('Settings persistence', xxx)

        if conf.env['DBUS_SERVICES_DIR'] != conf.env['DBUS_SERVICES_DIR_REAL']:
            print
            print Logs.colors.RED + "WARNING: D-Bus session services directory as reported by pkg-config is"
            print Logs.colors.RED + "WARNING:",
            print Logs.colors.CYAN + conf.env['DBUS_SERVICES_DIR_REAL']
            print Logs.colors.RED + 'WARNING: but service file will be installed in'

=== common/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import Build
import re
import os

def configure(conf):
    conf.check_cc(header_name='samplerate.h', define_name="HAVE_SAMPLERATE")
   
    if conf.is_defined('HAVE_SAMPLERATE'):
        conf.env['LIB_SAMPLERATE'] = ['samplerate']

    conf.env['BUILD_ADAPTER'] = conf.is_defined('HAVE_SAMPLERATE')

def create_jack_process_obj(bld, target, sources, uselib = None):
    process = bld.new_task_gen('cxx', 'shlib')
    process.env['shlib_PATTERN'] = '%s.so'
    process.defines  = ['HAVE_CONFIG_H','SERVER_SIDE']
    if bld.env['IS_MACOSX']:
        env_includes = ['../macosx', '../posix', '../macosx/coreaudio']
    if bld.env['IS_LINUX']:
	env_includes = ['../linux', '../posix', '../linux/alsa']
    if bld.env['IS_SUN']:
        env_includes = ['../solaris', '../posix', '../solaris/oss']
    process.includes = ['.'] + env_includes + ['jack', '..']
    process.name     = target
    process.target   = target
    process.source   = sources
    if bld.env['IS_LINUX']:
        process.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    if bld.env['IS_MACOSX']:
        process.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
        #process.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
        process.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    process.install_path = '${ADDON_DIR}/'
    process.uselib_local = uselib.name
    return process

def build(bld):
    common_libsources = [
        'JackActivationCount.cpp',
        'JackAPI.cpp',
        'JackClient.cpp',
        'JackConnectionManager.cpp',
        'ringbuffer.c',
        'JackError.cpp',
        'JackFrameTimer.cpp',
        'JackGraphManager.cpp',
        'JackPort.cpp',
        'JackPortType.cpp',
        'JackAudioPort.cpp',
        'JackMidiPort.cpp',
        'JackMidiAPI.cpp',
        'JackEngineControl.cpp',
        'JackShmMem.cpp',
        'shm.c',
        'JackGlobals.cpp',
        'JackDebugClient.cpp',
        'JackTransportEngine.cpp',
        'timestamps.c',
        'JackTools.cpp',
        'JackMessageBuffer.cpp',
        'JackEngineProfiling.cpp',
        ]

    includes = ['.', './jack', '..']
    uselib = ["PTHREAD"]

    if bld.env['IS_LINUX']:
        common_libsources += [
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixSemaphore.cpp',
            '../posix/JackFifo.cpp',
            '../posix/JackProcessSync.cpp',
            '../posix/JackSocket.cpp',
            '../linux/JackLinuxTime.c',
            ]
        includes = ['../linux', '../posix'] + includes
        uselib.append('RT')
        uselib.append('DL')

    if bld.env['IS_SUN']:
        common_libsources += [
           '../posix/JackPosixThread.cpp',
           '../posix/JackFifo.cpp',
           '../posix/JackProcessSync.cpp',
           '../posix/JackSocket.cpp',
           '../solaris/JackSolarisTime.c',
           ]
        includes = ['../solaris', '../posix'] + includes
        uselib.append('RT')

    if bld.env['IS_MACOSX']:
        common_libsources += [
            '../posix/JackProcessSync.cpp',
            '../posix/JackPosixThread.cpp',
            '../macosx/JackMachThread.cpp',
            '../macosx/JackMachSemaphore.cpp',
            '../posix/JackSocket.cpp',
            '../macosx/JackMachTime.c',
            ]
        includes = ['../macosx', '../macosx/RPC', '../posix'] + includes

    serverlib = bld.new_task_gen('cxx', 'shlib')
    serverlib.features.append('cc')
    serverlib.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    serverlib.includes = includes
    serverlib.name         = 'serverlib'
    serverlib.target       = 'jackserver'
    serverlib.uselib = uselib
    serverlib.install_path = '${LIBDIR}'
    serverlib.source = [] + common_libsources
    serverlib.source += [
        'JackAudioDriver.cpp',
        'JackMidiDriver.cpp',
        'JackDriver.cpp',
        'JackEngine.cpp',
        'JackExternalClient.cpp',
        'JackFreewheelDriver.cpp',
        'JackInternalClient.cpp',
        'JackServer.cpp',
        'JackThreadedDriver.cpp',
        'JackRestartThreadedDriver.cpp',
        'JackWaitThreadedDriver.cpp',
        'JackServerAPI.cpp',
        'JackDriverLoader.cpp',
        'JackServerGlobals.cpp',
        'JackControlAPI.cpp',
        'JackNetTool.cpp',
        'JackNetInterface.cpp',
        'JackArgParser.cpp',
        'JackPhysicalMidiInput.cpp',
        'JackPhysicalMidiOutput.cpp',
        ]

    if bld.env['IS_LINUX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_SUN']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_MACOSX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    serverlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        serverlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")

    if bld.env['IS_MACOSX']:
        serverlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
        serverlib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
        #serverlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module -arch i386 -arch ppc")
        serverlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework CoreFoundation -framework vecLib -single_module")
        serverlib.env.append_value("LINKFLAGS", "-compatibility_version 1 -current_version 1")

    if bld.env['IS_SUN']:
        serverlib.env.append_value("LINKFLAGS", "-lnsl -lsocket")

    clientlib = bld.new_task_gen('cxx', 'shlib')
    clientlib.features.append('cc')
    clientlib.defines = 'HAVE_CONFIG_H'
    clientlib.uselib = uselib
    clientlib.install_path = '${LIBDIR}'
    if bld.env['BUILD_JACKDBUS'] == True and bld.env['BUILD_JACKD'] == False:
        clientlib.uselib.append('DBUS-1')
    clientlib.includes = includes
    clientlib.name         = 'clientlib'
    clientlib.target       = 'jack'
    clientlib.source = [] + common_libsources
    clientlib.source += [
        'JackLibClient.cpp',
        'JackLibAPI.cpp',
        ]

    if bld.env['IS_LINUX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_SUN']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    clientlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        clientlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    
    if bld.env['IS_MACOSX']:
        clientlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
        clientlib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
        #clientlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module -arch i386 -arch ppc"
        clientlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module")
        clientlib.env.append_value("LINKFLAGS", "-compatibility_version 1 -current_version 1")

    if bld.env['IS_SUN']:
        clientlib.env.append_value("LINKFLAGS", "-lnsl -lsocket")

    if bld.env['BUILD_WITH_32_64']:
        print "create 32bit lib..."
        clientlib32bit = clientlib.clone('lib32')
  
    create_jack_process_obj(bld, 'netmanager', 'JackNetManager.cpp', serverlib)

    create_jack_process_obj(bld, 'profiler', 'JackProfiler.cpp', serverlib)

    net_adapter_sources = [
        'JackResampler.cpp',
        'JackLibSampleRateResampler.cpp',
        'JackAudioAdapter.cpp',
        'JackAudioAdapterInterface.cpp',
        'JackNetAdapter.cpp',
        ]

    if bld.env['BUILD_ADAPTER'] == True:
        process = create_jack_process_obj(bld, 'netadapter', net_adapter_sources, serverlib)
        process.uselib = 'SAMPLERATE'

    audio_adapter_sources = [
        'JackResampler.cpp',
        'JackLibSampleRateResampler.cpp',
        'JackAudioAdapter.cpp',
        'JackAudioAdapterInterface.cpp',
        'JackAudioAdapterFactory.cpp',
         ]

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_MACOSX']:
         audio_adapter_sources += ['../macosx/coreaudio/JackCoreAudioAdapter.cpp']
         process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)
         process.env.append_value("LINKFLAGS", "-framework CoreAudio -framework AudioUnit -framework AudioToolbox -framework CoreServices")
         process.uselib = 'SAMPLERATE'

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_LINUX'] and bld.env['BUILD_DRIVER_ALSA']:
         audio_adapter_sources += ['../linux/alsa/JackAlsaAdapter.cpp']
         process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)
         process.uselib = ['ALSA', 'SAMPLERATE']

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_SUN']:
         audio_adapter_sources += ['../solaris/oss/JackOSSAdapter.cpp', 'memops.c']
         process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)
         process.uselib = 'SAMPLERATE'

    #audio_adapter_sources += ['../windows/JackPortAudioAdapter.cpp']
    #process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)

    bld.install_files('${PREFIX}/include/jack', 'jack/*.h')

    # process jack.pc.in -> jack.pc
    import misc
    obj = bld.new_task_gen('subst')
    obj.source = '../jack.pc.in'
    obj.target = 'jack.pc'
    obj.dict = {'PREFIX': bld.env['PREFIX'],
                'LIBDIR': bld.env['LIBDIR'],
                'INCLUDEDIR': os.path.normpath(bld.env['PREFIX'] + '/include'),
                'SERVERLIB': serverlib.target,
                'JACK_VERSION': bld.env['JACK_VERSION'],
                }
    obj.install_path = '${LIBDIR}/pkgconfig/'
    obj.fun = misc.subst_func

=== dbus/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os.path
import Options
import re # subst_func
import Logs

def set_options(opt):
    opt.add_option('--enable-pkg-config-dbus-service-dir', action='store_true', default=False, help='force D-Bus service install dir to be one returned by pkg-config')

def configure(conf):
    conf.env['BUILD_JACKDBUS'] = False

    if not conf.check_cfg(package='dbus-1', atleast_version='1.0.0', args='--cflags --libs') or not conf.is_defined('HAVE_DBUS_1'):
        print Logs.colors.RED + 'WARNING !! jackdbus will not be built because libdbus-dev is missing' + Logs.colors.NORMAL
        return

    dbus_dir = conf.check_cfg(package='dbus-1', args='--variable=session_bus_services_dir')
    if not dbus_dir:
        print Logs.colors.RED + 'WARNING !! jackdbus will not be built because service dir is unknown' + Logs.colors.NORMAL
        return

    dbus_dir = dbus_dir.strip()
    conf.env['DBUS_SERVICES_DIR_REAL'] = dbus_dir

    if Options.options.enable_pkg_config_dbus_service_dir:
        conf.env['DBUS_SERVICES_DIR'] = dbus_dir
    else:
        conf.env['DBUS_SERVICES_DIR'] = os.path.normpath(conf.env['PREFIX'] + '/share/dbus-1/services')

    conf.check_tool('misc')

    conf.check(header_name='expat.h', define_name="HAVE_EXPAT")

    if conf.is_defined('HAVE_EXPAT'):
        conf.env['LIB_EXPAT'] = ['expat']
    else:
        print Logs.colors.RED + 'WARNING !! jackdbus will not be built because of expat is missing' + Logs.colors.NORMAL
        return

    conf.env['BUILD_JACKDBUS'] = True

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    if bld.env['IS_LINUX']:
        sysdeps_dbus_include = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        sysdeps_dbus_include = ['../macosx', '../posix']

    obj.includes = sysdeps_dbus_include + ['.', '../', '../common', '../common/jack']
    obj.source = [
        'jackdbus.c',
        'controller.c',
        'controller_iface_configure.c',
        'controller_iface_control.c',
        'controller_iface_introspectable.c',
        'controller_iface_patchbay.c',
        'controller_iface_transport.c',
        'xml.c',
        'xml_expat.c',
        #'xml_libxml.c',
        #'xml_nop.c',
        'xml_write_raw.c',
        'sigsegv.c',
	'reserve.c',
        ]
    if bld.env['IS_LINUX']:
        obj.uselib = 'PTHREAD DL RT DBUS-1 EXPAT'
    if bld.env['IS_MACOSX']:
        obj.uselib = 'PTHREAD DL DBUS-1 EXPAT'
    obj.uselib_local = 'serverlib'
    obj.target       = 'jackdbus'

    # process org.jackaudio.service.in -> org.jackaudio.service
    import misc
    obj = bld.new_task_gen('subst')
    obj.source = 'org.jackaudio.service.in'
    obj.target = 'org.jackaudio.service'
    obj.dict = {'BINDIR': bld.env['PREFIX'] + '/bin'}
    obj.install_path = '${DBUS_SERVICES_DIR}/'
    obj.fun = misc.subst_func

=== example-clients/wscript ===
#! /usr/bin/env python
# encoding: utf-8

example_programs = {
    'jack_freewheel' : 'freewheel.c',
    'jack_connect' : 'connect.c',
    'jack_lsp' : 'lsp.c',
    'jack_metro' : 'metro.c',
    'jack_midiseq' : 'midiseq.c',
    'jack_midisine' : 'midisine.c',
    'jack_showtime' : 'showtime.c',
    'jack_simple_client' : 'simple_client.c',
    'jack_zombie' : 'zombie.c',
    'jack_load' : 'ipload.c',
    'jack_unload' : 'ipunload.c',
    'jack_showtime' : 'showtime.c',
    'jack_alias' : 'alias.c',
    'jack_bufsize' : 'bufsize.c',
    'jack_wait' : 'wait.c',
    'jack_samplerate' : 'samplerate.c',
    'jack_evmon' : 'evmon.c',
    'jack_monitor_client' : 'monitor_client.c',
    'jack_thru' : 'thru_client.c',
    'jack_cpu_load' : 'cpu_load.c',
    'jack_simple_session_client' : 'simple_session_client.c',
    'jack_session_notify' : 'session_notify.c',
    'jack_server_control' : 'server_control.cpp',
    'jack_latent_client' : 'latent_client.c',
    'jack_midi_dump' : 'midi_dump.c',
    }

example_libs = {
    'inprocess' : 'inprocess.c',
    }

def configure(conf):
    e = conf.check_cc(header_name='sndfile.h', define_name="HAVE_SNDFILE")
 
    conf.check_cc(header_name='samplerate.h', define_name="HAVE_SAMPLERATE")
   
    if conf.is_defined('HAVE_SAMPLERATE'):
        conf.env['LIB_SAMPLERATE'] = ['samplerate']

    if conf.is_defined('HAVE_SNDFILE'):
        conf.env['LIB_SNDFILE'] = ['sndfile']

    conf.check_cfg(package='celt', atleast_version='0.5.0', args='--cflags --libs')

    e = conf.check_cc(header_name='ncurses.h', define_name="HAVE_NCURSES")

    if conf.is_defined('HAVE_NCURSES'):
        conf.env['LIB_NCURSES'] = ['ncurses']

    e = conf.check_cc(lib='readline', define_name="HAVE_READLINE")

    # define_name="HAVE_READLINE" has no effect, LIB_READLINE is defined if readline is available
    #if conf.is_defined('HAVE_READLINE'):
    #    conf.env['LIB_READLINE'] = ['readline']

    conf.env['BUILD_EXAMPLE_CLIENT_TRANSPORT'] = bool(conf.env['LIB_READLINE']) and bool(conf.env['LIB_NCURSES'])

    conf.env['BUILD_EXAMPLE_CLIENT_REC'] = conf.is_defined('HAVE_SNDFILE')

    conf.env['BUILD_EXAMPLE_ALSA_IO'] = conf.is_defined('HAVE_SAMPLERATE') and conf.env['BUILD_DRIVER_ALSA']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    for example_program, example_program_source in example_programs.items():
        prog = bld.new_task_gen('cxx', 'program')
        prog.features.append('cc')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_program_source
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.uselib = 'RT'
        if bld.env['IS_SUN']:
            prog.env.append_value("LINKFLAGS", "-lm")
        if example_program == 'jack_server_control':
            prog.uselib_local = 'serverlib'
        else:
            prog.uselib_local = 'clientlib'              
        prog.target = example_program
   
    if bld.env['BUILD_EXAMPLE_CLIENT_TRANSPORT']:
        prog = bld.new_task_gen('cc', 'program')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'transport.c'
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.uselib = 'RT READLINE NCURSES'
        if bld.env['IS_MACOSX']:
	    prog.uselib = 'READLINE NCURSES'
        prog.uselib_local = 'clientlib'
        prog.target = 'jack_transport'

    if bld.env['BUILD_EXAMPLE_CLIENT_REC']:
        prog = bld.new_task_gen('cc', 'program')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'capture_client.c'
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
            prog.env.append_value("LINKFLAGS", "")
            prog.uselib = 'SNDFILE'
        if bld.env['IS_LINUX']:
            prog.uselib = 'RT SNDFILE'
        if bld.env['IS_SUN']:
            prog.uselib = 'RT SNDFILE'
        prog.uselib_local = 'clientlib'
        prog.target = 'jack_rec'

    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX']:
        prog = bld.new_task_gen('cc', 'program')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['netsource.c', '../common/netjack_packet.c']
        prog.env.append_value("CCFLAGS", "-DNO_JACK_ERROR")
        prog.uselib = 'CELT SAMPLERATE'
        prog.uselib_local = 'clientlib'
        prog.target = 'jack_netsource'

    if bld.env['IS_LINUX'] and bld.env['BUILD_EXAMPLE_ALSA_IO']:
 	    prog = bld.new_task_gen('cc', 'program')
 	    prog.includes = os_incdir + ['../common/jack', '../common']
 	    prog.source = ['alsa_in.c', '../common/memops.c']
 	    prog.env.append_value("CCFLAGS", "-DNO_JACK_ERROR")
 	    prog.uselib = 'ALSA SAMPLERATE'
 	    prog.uselib_local = 'clientlib'
 	    prog.target = 'alsa_in'

 	    prog = bld.new_task_gen('cc', 'program')
 	    prog.includes = os_incdir + ['../common/jack', '../common']
 	    prog.source = ['alsa_out.c', '../common/memops.c']
 	    prog.env.append_value("CCFLAGS", "-DNO_JACK_ERROR")
 	    prog.uselib = 'ALSA SAMPLERATE'
 	    prog.uselib_local = 'clientlib'
 	    prog.target = 'alsa_out'

    for example_lib, example_lib_source in example_libs.items():
        lib = bld.new_task_gen('cc', 'shlib')
        lib.env['shlib_PATTERN'] = '%s.so'
        lib.includes = os_incdir + ['../common/jack', '../common']
        lib.target = example_lib
        lib.source = example_lib_source
        if bld.env['IS_MACOSX']:
            lib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
            #lib.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
            lib.env.append_value("LINKFLAGS", "")
        if bld.env['IS_SUN']:
	        lib.env.append_value("LINKFLAGS", "-lm")
        lib.uselib_local = 'serverlib'
        lib.install_path = '${ADDON_DIR}/'

    bld.symlink_as('${PREFIX}/bin/jack_disconnect', 'jack_connect')

    bld.install_files('${PREFIX}/bin', 'jack_control', chmod=0755)

=== linux/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def configure(conf):
    conf.check_cfg(package='alsa', atleast_version='1.0.18', args='--cflags --libs')
    conf.env['BUILD_DRIVER_ALSA'] = conf.is_defined('HAVE_ALSA')

    conf. check_cfg(package='libfreebob', atleast_version='1.0.0', args='--cflags --libs')
    conf.env['BUILD_DRIVER_FREEBOB'] = conf.is_defined('HAVE_LIBFREEBOB')

    conf. check_cfg(package='libffado', atleast_version='1.999.17', args='--cflags --libs')
    conf.env['BUILD_DRIVER_FFADO'] = conf.is_defined('HAVE_LIBFFADO')

    conf.define('HAVE_PPOLL', 1 )


def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE', 'HAVE_PPOLL']
    driver.includes = ['.', '../linux', '../posix', '../common', '../common/jack', '../dbus']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    if uselib:
        driver.uselib = uselib
    driver.uselib_local = 'serverlib'
    return driver

def build(bld):
    if bld.env['BUILD_JACKD'] == True:
        jackd = bld.new_task_gen('cxx', 'program')
        jackd.includes = ['../linux', '../posix', '../common/jack', '../common', '../dbus']
        jackd.defines = 'HAVE_CONFIG_H'
        jackd.source = ['../common/Jackdmp.cpp']
	if bld.env['IS_LINUX'] and bld.env['BUILD_JACKDBUS']: 
            jackd.source += ['../dbus/reserve.c', '../dbus/audio_reserve.c'] 
            jackd.uselib = 'PTHREAD DL RT DBUS-1'
	else:
            jackd.uselib = 'PTHREAD DL RT'		
        jackd.uselib_local = 'serverlib'
        jackd.target = 'jackd'
  	
    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')
    
    alsa_driver_src = [
                       'alsa/JackAlsaDriver.cpp',
                       'alsa/alsa_rawmidi.c',
                       'alsa/alsa_seqmidi.c',
                       'alsa/alsa_midi_jackmp.cpp',
                       '../common/memops.c',
                       'alsa/generic_hw.c',
                       'alsa/hdsp.c',
		       'alsa/alsa_driver.c',
                       'alsa/hammerfall.c',
                       'alsa/ice1712.c'
                       ]

    ffado_driver_src = ['firewire/JackFFADODriver.cpp',
                        'firewire/JackFFADOMidiInput.cpp',
                        'firewire/JackFFADOMidiOutput.cpp',
                        '../common/JackPhysicalMidiInput.cpp',
                        '../common/JackPhysicalMidiOutput.cpp'
                       ]

    if bld.env['BUILD_DRIVER_ALSA'] == True:
        create_jack_driver_obj(bld, 'alsa', alsa_driver_src, "ALSA")

    if bld.env['BUILD_DRIVER_FREEBOB'] == True:
        create_jack_driver_obj(bld, 'freebob', 'freebob/JackFreebobDriver.cpp', "LIBFREEBOB")

    if bld.env['BUILD_DRIVER_FFADO'] == True:
        create_jack_driver_obj(bld, 'firewire', ffado_driver_src, "LIBFFADO")

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_driver_obj(bld, 'netone', [ '../common/JackNetOneDriver.cpp',
                                            '../common/netjack.c',
                                            '../common/netjack_packet.c' ], "SAMPLERATE CELT" )

=== macosx/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    if uselib:
        driver.uselib = uselib
    return driver

def create_jack_audio_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    driver.env.append_value("LINKFLAGS", "-framework CoreAudio -framework CoreServices -framework AudioUnit")
    if uselib:
        driver.uselib = uselib
    return driver

def create_jack_midi_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    driver.env.append_value("LINKFLAGS", "-framework CoreMIDI -framework CoreServices -framework AudioUnit")
    if uselib:
        driver.uselib = uselib
    return driver

def build(bld):
    if bld.env['BUILD_JACKD'] == True:
    	jackd = bld.new_task_gen('cxx', 'program')
    	jackd.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    	jackd.defines = 'HAVE_CONFIG_H'
    	jackd.source = ['../common/Jackdmp.cpp']
    	jackd.uselib = 'PTHREAD DL'
    	jackd.uselib_local = 'serverlib'
    	jackd.env.append_value("LINKFLAGS", "-framework CoreFoundation")
    	jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_audio_driver_obj(bld, 'coreaudio', 'coreaudio/JackCoreAudioDriver.cpp')

    create_jack_midi_driver_obj(bld, 'coremidi', 'coremidi/JackCoreMidiDriver.cpp')
    
    portaudio_src = [
        '../windows/JackPortAudioDriver.cpp',
        '../windows/JackPortAudioDevices.cpp',
    	]

    #create_jack_audio_driver_obj(bld, 'portaudio', portaudio_src)

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'netone', [ '../common/JackNetOneDriver.cpp',
		                            '../common/netjack.c',
					    '../common/netjack_packet.c' ], "SAMPLERATE CELT" )

=== solaris/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    #driver.env.append_unique('CXXFLAGS', '-march=i686 -msse3 -ffast-math')
    #driver.env.append_unique('CCFLAGS', '-march=i686  -msse3  -ffast-math')
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '..','../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    if uselib:
        driver.uselib = uselib
    return driver

def build(bld):
    jackd = bld.new_task_gen('cxx', 'program')
    jackd.includes = ['.','..', '../posix', '../common/jack', '../common']
    jackd.defines = 'HAVE_CONFIG_H'
    jackd.source = ['../common/Jackdmp.cpp']
    jackd.uselib = 'PTHREAD DL'
    jackd.uselib_local = 'serverlib'
    jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'oss', ['oss/JackOSSDriver.cpp', '../common/memops.c'])

    create_jack_driver_obj(bld, 'boomer', ['oss/JackBoomerDriver.cpp', '../common/memops.c'])

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

=== tests/wscript ===
#! /usr/bin/env python
# encoding: utf-8

test_programs = {
    # For testing purposes
    #'synchroClient': ['testSynchroClient.cpp'],
    #'synchroServer': ['testSynchroServer.cpp'],
    #'synchroServerClient': ['testSynchroServerClient.cpp'],
    #'testSem': ['testSem.cpp'],
    'jack_test': ['test.cpp'],
    'jack_cpu': ['cpu.c'],
    'jack_iodelay': ['iodelay.cpp'],
    'jack_multiple_metro' : ['external_metro.cpp'],
    }

def build(bld):
    for test_program, test_program_sources in test_programs.items():
        prog = bld.new_task_gen('cxx', 'program')
        prog.features.append('cc')
        if bld.env['IS_MACOSX']:
	        prog.includes = ['..','../macosx', '../posix', '../common/jack', '../common']
        if bld.env['IS_LINUX']:
	        prog.includes = ['..','../linux', '../posix', '../common/jack', '../common']
        if bld.env['IS_SUN']:
	        prog.includes = ['..','../solaris', '../posix', '../common/jack', '../common']
        prog.source = test_program_sources
        if bld.env['IS_LINUX']:
            prog.uselib = 'RT'
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc")
	    prog.env.append_value("LINKFLAGS", "")
        prog.uselib_local = 'clientlib'
        prog.target = test_program

=== debian/changelog ===
jackd2 (1.9.7~dfsg-1ubuntu2) oneiric; urgency=low

  * Drop dh-buildinfo build-dependency; this creates conflicting
    per-architecture buildinfo.gz files that prevent multiarch
    co-installability, and all this information is already available in the
    build logs.
  * Build for multiarch.  LP: #861025.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Sep 2011 05:55:59 +0000

jackd2 (1.9.7~dfsg-1ubuntu1) oneiric; urgency=low

  * Merge from debian experimental, remaining changes:
    - Drop libcelt build dependency
    - debian/gbp.conf: Set debian-branch to ubuntu

 -- Luke Yelavich <themuso@ubuntu.com>  Mon, 08 Aug 2011 14:38:08 +1000

jackd2 (1.9.7~dfsg-1) unstable; urgency=low

  * New upstream version 1.9.7 (ALSA resume, new latency API)
  * Build with --mixed on i386 to be compatible with amd64.
  * Don't patch jack_connect for fast consecutive calls anymore, it's now
    using the same code as in jackd1 and waits for the port connection to
    appear.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 31 Mar 2011 13:54:50 +0200

=== debian/control ===
Source: jackd2
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>, Jonas Smedegaard <dr@jones.dk>, Reinhard Tartler <siretart@tauware.de>
Build-Depends: cdbs (>= 0.4.93~),
 debhelper (>= 8.1.3~),
 d-shlibs,
 python,
 python-support,
 libsamplerate-dev,
 libasound2-dev (>= 1.0.18) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libdbus-1-dev,
 libexpat1-dev,
 libsndfile1-dev,
 libncurses-dev,
 libreadline-dev,
 libraw1394-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libffado-dev (>= 2.0.0) [amd64 i386 powerpc],
 g++-multilib [amd64],
 po-debconf
Standards-Version: 3.9.1
DM-Upload-Allowed: yes
Homepage: http://jackaudio.org/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/jackd2.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/jackd2.git;a=summary

Package: jackd2
Architecture: any
Replaces: libjack0 (<= 1.9.5~dfsg-13),
	jackd (<< 3),
	jack-daemon
Provides: jack-daemon
Conflicts: jack-daemon,
	jackd (<< 3)
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 coreutils (>= 4.0),
 python-dbus,
 debconf | debconf-2.0,
 libjack-jackd2-0 (= ${binary:Version})
Recommends: qjackctl,
 libpam-modules,
 jackd2-firewire [amd64 i386 powerpc]
Suggests: jack-tools,
 meterbridge
Description: JACK Audio Connection Kit (server and example clients)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the daemon jackd as well as some example clients.

Package: libjack-jackd2-0
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: jackd2 (>> ${binary:Version}),
 jackd2 (<< ${binary:Version}),
 libjack0,
 libjack-0.116
Suggests: jackd2 (= ${binary:Version})
Provides: libjack-0.116
Replaces: libjack-0.116
Description: JACK Audio Connection Kit (libraries)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the shared libraries.

Package: jackd2-firewire
Architecture: amd64 i386 powerpc
Provides: jackd-firewire
Replaces: jackd-firewire
Conflicts: jackd-firewire
Depends: ${shlibs:Depends},
 ${misc:Depends},
 jackd2 (= ${binary:Version})
Description: JACK Audio Connection Kit (FFADO and FreeBoB backends)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the IEEE1394 (FireWire) backends FFADO and FreeBoB.

Package: libjack-jackd2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libjack-jackd2-0 (= ${binary:Version}), 
 ${asound:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 pkg-config,
 libdbus-1-dev
Conflicts: libjack0.100.0-dev (<< 0.102.20-2),
 libjack-dev
Provides: libjack0.100.0-dev,
 libjack-dev-session,
 libjack-dev
Replaces: libjack0.71.2-0 (<< 0.75.0-1)
Description: JACK Audio Connection Kit (development files)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains files needed for the development of JACK applications
 and an API reference.

=== debian/rules ===
#!/usr/bin/make -f

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

# suppress optional build-dependencies
CDBS_BUILD_DEPENDS_rules_upstream-tarball =
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

DEB_UPSTREAM_PACKAGE = jack
DEB_UPSTREAM_URL = http://www.grame.fr/~letz/
DEB_UPSTREAM_TARBALL_EXTENSION = tar.bz2

# unneeded and possibly sourceless binaries
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./windows/**.Lib ./windows/**.lib ./windows/**.dll
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./macosx/libcelt.a ./macosx/libportaudio.a

# unneeded sources copyright-protected without licence
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./windows/**.rc

# pure garbage in upstream tarball
DEB_UPSTREAM_REPACKAGE_EXCLUDES += .DS_Store

# ignore oddly packaged bzip2 archive to not upset dpkg
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^\./waf|\./debian/(changelog|copyright(|_hints|_newhints))$

# Minimum assured version referenced upstream as library API/ABI
ABI = 0.118.0

# Let's try to cut down noisy symbols to the official API
CFLAGS += -fvisibility=hidden
CXXFLAGS += -fvisibility=hidden

waf-configure-options = --prefix=/usr --classic --dbus \
	--libdir=/lib/$(DEB_HOST_MULTIARCH)
waf-configure-options += $(if $(filter linux,$(DEB_HOST_ARCH_OS)),--alsa)
waf-configure-options += $(if $(filter amd64 i386 powerpc,$(DEB_HOST_ARCH)),--firewire)
waf-configure-options += $(if $(filter amd64,$(DEB_HOST_ARCH)),--mixed)
waf-configure-options += $(if $(filter i386,$(DEB_HOST_ARCH)),--mixed)

DEB_MAKE_INVOKE = ./waf -v --destdir=$(CURDIR)/debian/tmp
DEB_MAKE_INSTALL_TARGET = install

# TODO: use distclean and drop related clean target, when (or if)
# upstream stop shipping waf dir
DEB_MAKE_CLEAN_TARGET = clean
clean::
	rm -f .lock-wscript
	find ./.waf-* -iname '*.pyc' -exec rm '{}' \;
	rm -f man/*.1
	rm -rf build

DEB_DH_MAKESHLIBS_ARGS = -Xintime -Xinprocess -Xjack_alsa -Xjack_oss -Xjack_dummy -Xjack_firewire

# too noisy symbols, so only watch disappearing ones for now
DEB_DH_MAKESHLIBS_ARGS += -- -c1

# Generate (and cleanup) files containing variables static per build
infiles = $(filter-out debian/control.in, $(wildcard debian/*.in))
outfiles = $(basename $(infiles))
DEB_PHONY_RULES += $(outfiles)
pre-build:: $(outfiles)
$(outfiles): update-config debian/stamp-copyright-check
	sed 's/__ABI__/$(ABI)/' <$@.in >$@
clean::
	rm -f $(outfiles)

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: debian/stamp-waf-configure
debian/stamp-waf-configure:
	./waf configure $(waf-configure-options)
	touch $@
clean::
	rm -f debian/stamp-waf-configure

install/jackd2::
ifeq ($(DEB_HOST_ARCH_OS),linux)
	dh_install -pjackd2 debian/tmp/usr/bin/alsa_in
	dh_install -pjackd2 debian/tmp/usr/bin/alsa_out
	dh_install -pjackd2 debian/tmp/usr/lib/*/jack/jack_alsa.so
	dh_install -pjackd2 debian/tmp/usr/lib/*/jack/audioadapter.so
endif	

binary-install/jackd2::
	dh_pysupport -pjackd2

# TODO: drop libstdc++6 override when bug#374049 closed in stable
binary-post-install/libjack0::
	d-devlibdeps \
		--override s/libjackserver0-dev// \
		--override s/libffado2-dev/libffado-dev/ \
		--override s/libcelt0-0-dev/libcelt-dev/ \
		--override s/libstdc++6-4.1-dev// \
		debian/libjack-dev.substvars \
		debian/tmp/usr/lib/*/*.so \
		debian/tmp/usr/lib/*/jack/*.so

#common-binary-post-install-arch::
#        ln -s jackdmp debian/jackdmp/usr/bin/jackd
